; 

    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\macros\macros.asm

    include lzw.inc
    include timers.asm

    include \masm32\include\debug.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib

    includelib lzw.lib

    includelib \masm32\lib\debug.lib

; 

m2m     MACRO M1, M2
            push M2
            pop  M1
        ENDM


; 

 .data
 align 16

    hInstance       dd 0
    hwnd            dd 0                ; owner window
    hf              dd 0                ; file handle
    MyHeap          dd 0
    Memory1         dd 0
    Memory2         dd 0
    tmp             dd 0
    lpString3       dd 0

    szFileName      db 'test',0         ;260 dup(0)       ; buffer for filename
    OFilter         db "All",0,"*.*",0,0
    SFilter         db "LZW",0,"*.lzw",0,0
    OTitle          db "Open...",0
    Error_OpenName  dd 0
                    db "OpenName",0
    Error_SaveName  dd 1
                    db "SaveName",0
    Error_Open      dd 2
                    db "Open",0
    Error_Create    dd 3
                    db "Create",0
    Error_Read      dd 4
                    db "Read",0
    Error_Write     dd 5
                    db "Write",0
; 

 .code
align 4

; 

Start:
 
; 

            invoke GetModuleHandle, NULL
            mov     hInstance,eax

            call GetProcessHeap
            mov     MyHeap,eax
; -------------------------------------------------------------------------

            mov     eax,FUNC(HeapAlloc,MyHeap,0,200000h)
            mov     Memory1,eax
            add     eax,100000h
            mov     Memory2,eax

; -------------------------------------------------------------------------
@_Encode:
            invoke LZW_init,10
            
            push offset OFilter
            call Read_File
            jnc @_Read_OK1
            jmp @_END
@_Read_OK1:
            invoke CloseHandle,hf

            timer_begin 1,HIGH_PRIORITY_CLASS

            invoke LZW_encode,Memory1,Memory2,tmp
            mov     tmp,eax

            timer_end
PrintHex eax

            push offset SFilter
            call Write_File
            jnc @_Write_OK1
            jmp @_END
@_Write_OK1:
            invoke CloseHandle,hf

            invoke LZW_destroy
; -------------------------------------------------------------------------
@_END:
            invoke HeapDestroy,MyHeap

            invoke ExitProcess,eax
; 

; 

Read_File   PROC Filter:DWORD
; ----------------
@_ReadFile_OK1:
            mov     eax,FUNC(CreateFile,offset szFileName,GENERIC_READ,0,0,OPEN_EXISTING,0,NULL)
            cmp     eax,INVALID_HANDLE_VALUE
            jnz @_ReadFile_OK2
            lea     eax,Error_Open
            jmp     @_Error_END
; ----------------
@_ReadFile_OK2:
            mov     hf,eax
            mov     eax,FUNC(ReadFile,hf,Memory1,100000h,ADDR tmp,NULL)
            or      eax,eax
            jnz @_NoError_END
            lea     eax,Error_Read
; ----------------
@_Error_END:
            stc
            ret
; ----------------
@_NoError_END:
            clc
            ret
Read_File   ENDP
; 

; 
Write_File  PROC Filter:DWORD
; ----------------
@_WriteFile_OK1:
            mov     ecx,sizeof szFileName
            lea     esi,szFileName
@_WriteFile_OK11:
            mov     al,[esi]
            inc     esi
            cmp     al,'.'
            jz  @_WriteFile_OK2
            or      al,al
            jz  @_WriteFile_OK12
            dec     ecx
            jnz @_WriteFile_OK11
@_WriteFile_OK12:
            mov     eax,575A4C2Eh
            mov     [esi-1],eax
            mov     [esi+3],BYTE PTR 0
@_WriteFile_OK2:

            mov     eax,FUNC(CreateFile,offset szFileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,NULL)
            cmp     eax,INVALID_HANDLE_VALUE
            jnz @_WriteFile_OK3
            lea     eax,Error_Create
            jmp     @_Error_END
@_WriteFile_OK3:
            mov     hf,eax

            mov     eax,FUNC(WriteFile,hf,Memory2,tmp,ADDR tmp,NULL)
            or      eax,eax
            jnz @_NoError_END
            lea     eax,Error_Write
; ----------------
@_Error_END:
            stc
            ret
; ----------------
@_NoError_END:
            clc
            ret
Write_File  ENDP

; 

end Start
